library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;


entity dist_amp is
port (
	clk : in std_logic;
	reset_n : in std_logic;
	data_enable : in std_logic;
	distortion_enable : in std_logic;
	
	data_in : in std_logic_vector(15 downto 0);
	data_out : out std_logic_vector(15 downto 0);
	clip : in std_logic_vector(15 downto 0);
	data_ready : out std_logic
);
end dist_amp;
	
architecture rtl of dist_amp is

signal cut_value : std_logic_vector(15 downto 0);

begin

	process(clk,reset_n)
	begin
		if(reset_n = '0') then
			cut_value <= X"0000";
		else
			cut_value <= clip;
		end if;
	end process;

	process(clk,reset_n)
	begin
		if(reset_n = '0') then
			data_out <= X"0000";
		elsif(data_enable = '1') then
			data_ready <= '1';
			if(distortion_enable = '1') then
--				case (clip) is
--				when "1000000000000000" =>
					data_out <= data_in;
--				when "0100000000000000" =>
--					data_out <= data_in;
--				when "0010000000000000" =>
--					data_out <= data_in(14 downto 0) & '0';
--				when "0001000000000000" =>
--					data_out <= data_in(14 downto 0) & '0';
--				when "0000100000000000" =>
--					data_out <= data_in(14 downto 0) & '0';
--				when "0000010000000000" =>
--					data_out <= data_in(14 downto 0) & '0';
--				when "0000001000000000" =>
--					data_out <= data_in(13 downto 0) & "00";
--				when "0000000100000000" =>
--					data_out <= data_in(13 downto 0) & "00";
--				when "0000000010000000" =>
--					data_out <= data_in(13 downto 0) & "00";
--				when "0000000001000000" =>
--					data_out <= data_in(13 downto 0) & "00";
--				when "0000000000100000" =>
--					data_out <= data_in(13 downto 0) & "00";
--				when "0000000000010000" =>
--					data_out <= data_in(13 downto 0) & "00";
--				when "0000000000001000" =>
--					data_out <= data_in(13 downto 0) & "00";
--				when "0000000000000100" =>
--					data_out <= data_in(13 downto 0) & "00";
--				when "0000000000000010" =>
--					data_out <= data_in(12 downto 0) & "000";
--				when "0000000000000001" =>
--					data_out <= data_in(12 downto 0) & "000";
--				when others =>
--					data_out <= data_in;
--				end case;
			else
				data_out <= data_in;
			end if;
		else
			data_ready <= '0';
		end if;
	end process;
end architecture;