library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;

entity edgedector is
port (
	edge, clk: in std_logic;
	P : out std_logic
	);
end edgedector;

architecture rtl of edgedector is

 signal state : std_logic := '0';
 signal prev_edge : std_logic;
begin

P <= state; 

process(Clk)
	begin 
		if (clk'event and clk = '1') then
			if(edge = '1' and prev_edge = '0') then -- when pressed
				prev_edge <= edge;
				state <= not state;
			else 
				if (edge = '0' and prev_edge = '1') then -- when released
					prev_edge <= edge;
				end if;
			end if;
		end if;
	end process;
end rtl;
	