--Legal Notice: (C)2006 Altera Corporation. All rights reserved.  Your
--use of Altera Corporation's design tools, logic functions and other
--software and tools, and its AMPP partner logic functions, and any
--output files any of the foregoing (including device programming or
--simulation files), and any associated documentation or information are
--expressly subject to the terms and conditions of the Altera Program
--License Subscription Agreement or other applicable license agreement,
--including, without limitation, that your use is for the sole purpose
--of programming logic devices manufactured by Altera and sold by Altera
--or its authorized distributors.  Please refer to the applicable
--agreement for further details.


-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity adapter_downstream_pipeline_5 is 
        port (
              -- inputs:
                 signal downstream_clk : IN STD_LOGIC;
                 signal downstream_endofpacket : IN STD_LOGIC;
                 signal downstream_readdata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal downstream_readdatavalid : IN STD_LOGIC;
                 signal downstream_reset_n : IN STD_LOGIC;
                 signal downstream_waitrequest : IN STD_LOGIC;
                 signal upstream_address : IN STD_LOGIC_VECTOR (2 DOWNTO 0);
                 signal upstream_arbiterlock : IN STD_LOGIC;
                 signal upstream_arbiterlock2 : IN STD_LOGIC;
                 signal upstream_burstcount : IN STD_LOGIC;
                 signal upstream_byteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal upstream_chipselect : IN STD_LOGIC;
                 signal upstream_debugaccess : IN STD_LOGIC;
                 signal upstream_nativeaddress : IN STD_LOGIC;
                 signal upstream_read : IN STD_LOGIC;
                 signal upstream_write : IN STD_LOGIC;
                 signal upstream_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);

              -- outputs:
                 signal downstream_address : OUT STD_LOGIC_VECTOR (2 DOWNTO 0);
                 signal downstream_arbiterlock : OUT STD_LOGIC;
                 signal downstream_arbiterlock2 : OUT STD_LOGIC;
                 signal downstream_burstcount : OUT STD_LOGIC;
                 signal downstream_byteenable : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal downstream_chipselect : OUT STD_LOGIC;
                 signal downstream_debugaccess : OUT STD_LOGIC;
                 signal downstream_nativeaddress : OUT STD_LOGIC;
                 signal downstream_read : OUT STD_LOGIC;
                 signal downstream_write : OUT STD_LOGIC;
                 signal downstream_writedata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal upstream_endofpacket : OUT STD_LOGIC;
                 signal upstream_readdata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal upstream_readdatavalid : OUT STD_LOGIC;
                 signal upstream_waitrequest : OUT STD_LOGIC
              );
end entity adapter_downstream_pipeline_5;


architecture europa of adapter_downstream_pipeline_5 is

begin

  --upstream, which is an e_avalon_adapter_slave
  --downstream, which is an e_avalon_adapter_master
  process (downstream_clk, downstream_reset_n)
  begin
    if downstream_reset_n = '0' then
      downstream_chipselect <= std_logic'('0');
    elsif downstream_clk'event and downstream_clk = '1' then
      if std_logic'(NOT downstream_waitrequest) = '1' then 
        downstream_chipselect <= upstream_chipselect;
      end if;
    end if;

  end process;

  upstream_endofpacket <= downstream_endofpacket;
  upstream_readdata <= downstream_readdata;
  upstream_readdatavalid <= downstream_readdatavalid;
  upstream_waitrequest <= downstream_waitrequest;
  process (downstream_clk)
  begin
    if downstream_clk'event and downstream_clk = '1' then
      if std_logic'(NOT downstream_waitrequest) = '1' then 
        downstream_address <= upstream_address;
      end if;
    end if;

  end process;

  process (downstream_clk)
  begin
    if downstream_clk'event and downstream_clk = '1' then
      if std_logic'(NOT downstream_waitrequest) = '1' then 
        downstream_arbiterlock <= upstream_arbiterlock;
      end if;
    end if;

  end process;

  process (downstream_clk)
  begin
    if downstream_clk'event and downstream_clk = '1' then
      if std_logic'(NOT downstream_waitrequest) = '1' then 
        downstream_arbiterlock2 <= upstream_arbiterlock2;
      end if;
    end if;

  end process;

  process (downstream_clk)
  begin
    if downstream_clk'event and downstream_clk = '1' then
      if std_logic'(NOT downstream_waitrequest) = '1' then 
        downstream_burstcount <= upstream_burstcount;
      end if;
    end if;

  end process;

  process (downstream_clk)
  begin
    if downstream_clk'event and downstream_clk = '1' then
      if std_logic'(NOT downstream_waitrequest) = '1' then 
        downstream_byteenable <= upstream_byteenable;
      end if;
    end if;

  end process;

  process (downstream_clk)
  begin
    if downstream_clk'event and downstream_clk = '1' then
      if std_logic'(NOT downstream_waitrequest) = '1' then 
        downstream_debugaccess <= upstream_debugaccess;
      end if;
    end if;

  end process;

  process (downstream_clk)
  begin
    if downstream_clk'event and downstream_clk = '1' then
      if std_logic'(NOT downstream_waitrequest) = '1' then 
        downstream_nativeaddress <= upstream_nativeaddress;
      end if;
    end if;

  end process;

  process (downstream_clk)
  begin
    if downstream_clk'event and downstream_clk = '1' then
      if std_logic'(NOT downstream_waitrequest) = '1' then 
        downstream_read <= upstream_read;
      end if;
    end if;

  end process;

  process (downstream_clk)
  begin
    if downstream_clk'event and downstream_clk = '1' then
      if std_logic'(NOT downstream_waitrequest) = '1' then 
        downstream_write <= upstream_write;
      end if;
    end if;

  end process;

  process (downstream_clk)
  begin
    if downstream_clk'event and downstream_clk = '1' then
      if std_logic'(NOT downstream_waitrequest) = '1' then 
        downstream_writedata <= upstream_writedata;
      end if;
    end if;

  end process;


end europa;

