library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity LRRequestBuffer_out is
port (
    clk : in std_logic;       --  Audio CODEC Chip Clock AUD_XCK (18.43 MHz)
	lrck : in std_logic;
	data_left : in std_logic;
	data_right : in std_logic;
    dataL_in : in std_logic_vector(15 downto 0);
    dataR_in : in std_logic_vector(15 downto 0);
    audio_req : in std_logic;

    data_out : out std_logic_vector(15 downto 0)	
    
  );
end  LRRequestBuffer_out;


architecture Behavioral of  LRRequestBuffer_out is     

signal buffer_left : std_logic_vector (15 downto 0);
signal buffer_right : std_logic_vector (15 downto 0);

begin     
    process(clk)
    begin
		if(clk 'event and clk = '1') then
			if(data_left = '1') then
				buffer_left <= dataL_in;
			end if;
			if(data_right = '1') then
				buffer_right <= dataR_in;
			end if;
			if(audio_req = '1') then
				if(lrck = '1') then
					data_out <= buffer_left;
  				else
					data_out <= buffer_right;
				end if;
			end if;
		end if;
    end process;

--	process(clk)
--	begin
--		if(clk 'event and clk = '1') then
--			if(audio_req = '1') then
--				if(lrck = '1') then
--					data_out <= buffer_left;
 -- 				else
--					data_out <= buffer_right;
--				end if;
--			end if;
--		end if;
--	end process;
    
end architecture;



