 library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity de2_wm8731_audio_in_TB is
end de2_wm8731_audio_in_TB;


architecture eda of de2_wm8731_audio_in_TB is
component de2_wm8731_audio_in is
port (
    clk : in std_logic;       --  Audio CODEC Chip Clock AUD_XCK (18.43 MHz)
    reset_n : in std_logic;
    data_out : out std_logic_vector(15 downto 0);
    audio_req : out std_logic;

    -- Audio interface signals
	AUD_ADCLRCK  : out std_logic;   --    Audio CODEC ADC LR Clock
    AUD_ADCDAT   : in  std_logic;   --    Audio CODEC ADC Data
    AUD_BCLK     : inout std_logic  --    Audio CODEC Bit-Stream Clock
  );
end  component;
 
signal clk : std_logic;
signal reset_n : std_logic;
signal AUD_ADCDAT : std_logic;   --    Audio CODEC ADC Data
signal AUD_BCLK : std_logic;
signal data_out : std_logic_vector(15 downto 0);
signal audio_req : std_logic;
    -- Audio interface signals
signal AUD_ADCLRCK  : std_logic;   --    Audio CODEC ADC LR Clock

begin

	P1: de2_wm8731_audio_in port map (
	    clk => clk,
	    reset_n => reset_n,
	    data_out => data_out,
		audio_req => audio_req,
	  
	    -- Audio interface signals
	    AUD_ADCLRCK  => AUD_ADCLRCK,
		AUD_ADCDAT => AUD_ADCDAT,
	    AUD_BCLK     => AUD_BCLK
	 );

	process
	begin
		clk <='0';
		reset_n <= '0';
		wait for 5 ns;
		clk <= '1';
		reset_n <= '1';
		wait for 5 ns;
		loop
			clk <='1';
			wait for 5 ns;
			clk <='0';
			wait for 5 ns;
		end loop;
	end process;

	process
	begin
		loop
		-- 1010 1110 1111 0010
		AUD_ADCDAT <= '1'; -- 1
		wait for 120 ns;
		AUD_ADCDAT <= '0'; -- 2
		wait for 120 ns;
		AUD_ADCDAT <= '1'; -- 3
		wait for 120 ns;
		AUD_ADCDAT <= '0'; -- 4
		wait for 120 ns;
		AUD_ADCDAT <= '1'; -- 5
		wait for 120 ns;
		AUD_ADCDAT <= '1'; -- 6
		wait for 120 ns;
		AUD_ADCDAT <= '1'; -- 7
		wait for 120 ns;
		AUD_ADCDAT <= '0'; -- 8
		wait for 120 ns;
		AUD_ADCDAT <= '1'; -- 9
		wait for 120 ns;
		AUD_ADCDAT <= '1'; -- 10
		wait for 120 ns;
		AUD_ADCDAT <= '1'; -- 11
		wait for 120 ns;
		AUD_ADCDAT <= '1'; -- 12
		wait for 120 ns;
		AUD_ADCDAT <= '0'; -- 13
		wait for 120 ns;
		AUD_ADCDAT <= '0'; -- 14
		wait for 120 ns;
		AUD_ADCDAT <= '1'; -- 15
		wait for 120 ns;
		AUD_ADCDAT <= '0'; -- 16
		wait for 120 ns;
		AUD_ADCDAT <= '1'; -- 1
		wait for 120 ns;
		AUD_ADCDAT <= '1'; -- 2
		wait for 120 ns;
		AUD_ADCDAT <= '1'; -- 3
		wait for 120 ns;
		AUD_ADCDAT <= '1'; -- 4
		wait for 120 ns;
		AUD_ADCDAT <= '0'; -- 5
		wait for 120 ns;
		AUD_ADCDAT <= '0'; -- 6
		wait for 120 ns;
		AUD_ADCDAT <= '0'; -- 7
		wait for 120 ns;
		AUD_ADCDAT <= '0'; -- 8
		wait for 120 ns;
		AUD_ADCDAT <= '1'; -- 9
		wait for 120 ns;
		AUD_ADCDAT <= '1'; -- 10
		wait for 120 ns;
		AUD_ADCDAT <= '1'; -- 11
		wait for 120 ns;
		AUD_ADCDAT <= '1'; -- 12
		wait for 120 ns;
		AUD_ADCDAT <= '0'; -- 13
		wait for 120 ns;
		AUD_ADCDAT <= '0'; -- 14
		wait for 120 ns;
		AUD_ADCDAT <= '0'; -- 15
		wait for 120 ns;
		AUD_ADCDAT <= '0'; -- 16
		end loop;	
	end process;
end eda;
